#!/usr/bin/perl
# toolvars      *** included perl script
#
# @(#)toolvars  12-11-1997
#
# 1996-11-27: add 'mfconcom'-var 'REL' for 'cbackup'
# 1994-01-20: let "OPTIMIZE" depend on "VMAKE_VERSION"
#
# included by several shell scripts, defines system specific values
#
use Env;

if ($RELVER eq ""){
	print "\n!!! WARNING:  RELVER not set!!!\n";
	exit 1;
}

$ADABAS_COPYRIGHT="Copyright  SAP AG 1997";
if ($RELVER eq "R61") {
	$ADABAS_VERSION="6.1";
}
elsif ($RELVER eq "R62") {
	$ADABAS_VERSION="6.2";
}
elsif ($RELVER eq "R70") {
	$ADABAS_VERSION="7.0";
}
elsif ($RELVER eq "R71") {
	$ADABAS_VERSION="7.1";
}
elsif ($RELVER eq "R72") {
	$ADABAS_VERSION="7.2";
}
elsif ($RELVER eq "R73") {
	$ADABAS_VERSION="7.3";
}


$SQLVERSION="REL30";$ENV{SQLVERSION} = $SQLVERSION; # export $SQLVERSION

$OSSPEC=AIX;
$ENV{OSSPEC} = $OSSPEC;		# export $OSSPEC
$MACH = "_IBMR2";
$ENV{MACH} = $MACH;		# export $MACH
$OS = "UNIX";
$ENV{OS}         = $OS;			# export $OS

$COMP="PTOC";
if ($RELVER eq "R61") {
	#@CONCOMOPTS = ( "-REL=R61" );
	@CONCOMOPTS = ( "-$SQLVERSION=1", "-REL=R61" );
	#@CONCOMOPTS = ( "-SAG=1", "-$SQLVERSION=1", "-REL=R61" );
}
else {
	#@CONCOMOPTS = ( );
	@CONCOMOPTS = ( "-$SQLVERSION=1" );
	#@CONCOMOPTS = ( "-SAG=1", "-$SQLVERSION=1" );
}
push @CONCOMOPTS, "-RELVER=$RELVER";
push @CONCOMOPTS, "-DIAGNOSE=1" if defined( $ENV{'DIAGNOSE'} );


if ( not $CC ) {
    $CC = "cc";
}
#else take CC from the environment
if ( not $CXX ) {
	if (($RELVER eq "R61") || ($RELVER eq "R62")) {
		$CXX = "xlC";
	} else {
		$CXX = "xlC_r";      # PTS 1001630
		$CC = "xlc_r";
	}
}
#else take CXX from the environment PTS 1001861

if ($RELVER ge "R72")  # &gar PTS 1002110
{
	$LD = $CXX;
}
else
{
	$LD	= $CC;
}
$AS		= $CC;
$AR		= "ar";
$NULL = "/dev/null";
# set C and CXX as environment variable
$ENV{CC}=$CC;
$ENV{CXX}=$CXX;
#
# Additional compiler flags may be set temporary in the environment
# before calling vmake.
#

@ASFLAGS = ();

# 98/06/19 &gar: for differences between C and C++-Compiling in UNIX !
# @CCFLAGS   -> FLAGS for both ( C, C++ )
# @CFLAGS    -> FLAGS for C only
# @CXXFLAGS  -> FLAGS for C++ only
  @CXXFLAGS = split /\s+/, $CXXFLAGS;
  @CFLAGS = split /\s+/, $CFLAGS;
@CCFLAGS = split /\s+/, $CCFLAGS;
push @CCFLAGS, "-D$SQLVERSION",  "-D$OSSPEC", "-D$MACH", "-DSAG";
push @CCFLAGS, "-DDIAGNOSE" if defined( $ENV{'DIAGNOSE'} );
@CCMODEANSI = ();
@CCMODENORM = ();
@CCMODELINT = ();


# RTS 1000166
@EXCEPT_FLAG = ();

push @CCFLAGS, "-D_REENTRANT", "-I$INSTROOT/incl", "-I$WRK/incl";

push @CCFLAGS, "-U__STR__", "-qchars=signed";
# push @CCFLAGS, "-D_LARGE_FILES"; # &gar: for large files
push @CFLAGS, "-D_NO_PROTO";
@LINTFLAGS = (@CCFLAGS,@CFLAGS);



# "OPTIMIZE" now depends on "VMAKE_VERSION" (needed on AIX)
if ($CURR_VERSION =~ /^f/i) {
    # the old value, it was used for everything
    # AIX - meaning of "-O" is unspecified, force the less risky
	@OPTIMIZE = "-O2";
}
else {
    # VMAKE_VERSION is quick or slow
    # one level less than fast - not yet really tested
    # the idea is to combine range checks with less risky code
    # AIX - switch off, compiler is faulty
    @OPTIMIZE = ();
}

# CTS 1103440
@DEBUG_FLAGS = ("-g");



# cba 98/07/16 : cause of differeces of C- and C++-Linker
# we may have different linker options on some UNIX-platforms
# we use @LDFLAGS for C-linking and @LDXXFLAGS for C++-Linking
# &gar 99/06/03: for linkdll new variable DLDFLAGS and DLDXXFLAGS
# ( PTS 1103001 )
# initialize
@LDFLAGS = @LDXXFLAGS = ("-bnoipath", "-brtl");
@DLDFLAGS = @DLDXXFLAGS = ();

# &gar PTS 1001828
@PRF_FLAGS = "-pg";

# &gar OFLAGS for call options
# used in link... and comp...
# always initialize here with ()
@OFLAGS=();

$SR_ID = "static char ident_sr[] =";
$MF_ID = "static char ident_mf[] =";
$PC_ID = "static char ident_pc[] =";
$CC_ID = "static char ident_cc[] =";
$ID_END= ";";

@PCFLAGS= ( "-qn", "-e" );
@ARFLAGS = ( "rcs" );
$RANLIB = "ar ts";


@LIBPC = ( "$TOOL/lib/libsqlptc.a" );	# static, not dynamic lib
@LIBPC_PROF = ( "$TOOL/lib/libsqlptc_p.a" );	# static, not dynamic lib
@LIBSCR = "-lcurses";
@LIBMATH = "-lm";
@DYNAMIC_LIB = ();
@LIBNET  = "-lbsd";
@LIBCSCI    = ();

#
# PTS 1002837 jrg 26.5.1999
@LIBMPROC = ();

@LIBAIO = ();


if ( $SQLVERSION eq "REL30" )  { $TRACETYPE = "tsp_trace" }
	else { $TRACETYPE = "tracetext" }

$SHELL = "/bin/sh"; $ENV{SHELL} = $SHELL;    # force Bourne shell even for C shell users

#################################################
# vmake environment variables must be set by hand
#################################################

if ( ! $DEVENV ) {
#   $DEVENV = "YES";		# Pascal vsp-modules
    $DEVENV = "NO";			# Assembler or C vsp-modules
}
$ENV{DEVENV} = $DEVENV; # export $DEVENV

undef($CCOMP);
$CCOMP = "GENC";
$ENV{CCOMP} = $CCOMP;
undef($CPPCOMP);
undef($COBCOMP);
undef($FORCOMP);
undef($PASCOMP);


# ================================================================

$DLL_TYPE = "so";
$ENV{DLL_TYPE} = $DLL_TYPE;		# can be exported even if not set

$ARCH_TYPE = ".a";
$ENV{ARCH_TYPE} = $ARCH_TYPE;		# can be exported even if not set

$PYTHON_INCLUDE = $ENV{TOOL} . "/Python/include";
$ENV{PYTHON_INCLUDE} = $PYTHON_INCLUDE;
$ACTIVEPERL_INCLUDE = "";
$ENV{ACTIVEPERL_INCLUDE} = $ACTIVEPERL_INCLUDE;
$ACTIVEPERL_LIB = "";
$ENV{ACTIVEPERL_LIB} = $ACTIVEPERL_LIB;
$COREPERL_INCLUDE = $ENV{TOOL} . "/Perl/lib/CORE";
$ENV{COREPERL_INCLUDE} = $COREPERL_INCLUDE;
$COREPERL_LIB = $ENV{TOOL} . "/Perl/lib/CORE";
$ENV{COREPERL_LIB} = $COREPERL_LIB;

$TraceFile = "$WRK/$VMAKE_VERSION/prot/trace.prot";
sub ToolTrace {
	# usage ToolTrace($string, \@daten)
	if ( $ENV{'TOOLTRACE'}) {
		local( $string, $r_daten ) = @_;
		open( TOOLTRACE, ">>$TraceFile") || die "Can't open $TraceFile (append): $!\n";
		print TOOLTRACE sprintf($string, @$r_daten);
		close(TOOLTRACE);
	}
}


# initializing flush of output buffer
$|=1; print "";
