#!/devtool/local/bin/perl
# linkdll       *** internal script (called by vmake !)
#
# @(#)linkdll		1997-11-18
#
# link object modules to create a shared library
#
# TOOL          directory for tools
# LDFLAGS       optional loader flags
# KEEPFLG       optional keep intermediate files flag
#
# 1994-06-02 J.Bruehe  modify for AIX import lists
#
# 1995-08-01	R. Appelt	Einbau des "-deflib"-Parameters
# 1997-02-04 GG: Map-Files werden nach $SYS/map/$VMAKE_VERSION verschoben
package linkdll;
use Env;
use File::Copy;
use Carp;
use ICopy;
# Get LDFLAGS, AR
do "$TOOL/bin/toolvars$TOOLEXT";
if ( $@ ) { print "$@"; exit }
ToolTrace("linkdll called with @ARGV\n");

$USAGE = "usage: linkdll [ld-flags] dll archive objects\n";

$MAP    = "";
$DEF    = "";
$NODLL  = "YES";
$DLLFLG = "";
$ENT    = "";
@Lib    = ();
@ELIB   = ();
$DEFLIB = "-nodefaultlib";
$DEBUG  = "";
$PROF   = "";
$SCRIPT = "";
$RCFILE = "";


while ($_ = $ARGV[0], /^-/) {
    shift;
    last if /^--$/;


    if(/^-k$/)     { @KEEPFLG = "-k"; next }

    if(/^-.*/)     { push @LDFLAGS, $_; next }

} #while

if ( @ARGV < 3 ) { print $USAGE; exit 1 }

$DLLFILE = shift;

if ( $OSBASE eq "Windows_NT" and ($DEBUG ne "" or $VMAKE_VERSION =~ /^slow/i)) { $STRIPDEBUG = "y" }

#some systems forbid some extensions for executables
if ($DLLFILE =~ /(.*)\.[fqs]/) { $DLL = $1} else { $DLL = $DLLFILE }

$ARCFILE = shift;

    # We have to separate the arguments into objects and import lists
    # because 1) only objects are given to "nm" for the export list
    # and     2) import lists must be searched in a hierarchy until found.
    @OBJECTS = ();
    @IMPLIST = ();

    foreach $F (@ARGV) {
		if ( $F =~ /-bI:(.*)/ ) {
			$IMPMOD = $F;
            if  ( -f "$WRK/fast/obj/$IMPMOD" ) {
				push @IMPLIST , "-bI:$WRK/fast/obj/$IMPMOD";
			}
            elsif ( -f "$WRK/quick/obj/$IMPMOD" ) {
				push @IMPLIST, "-bI:$WRK/quick/obj/$IMPMOD";
			}
            elsif ( -f "$WRK/slow/obj/$IMPMOD" ) {
				push @IMPLIST, "-bI:$WRK/slow/obj/$IMPMOD";
			}
            elsif ( -f "$TOOL/lib/$IMPMOD" ) {
				push @IMPLIST, "-bI:$TOOL/lib/$IMPMOD";
			}
            else {
				push @IMPLIST, $F;
			}
		}
		else { push @OBJECTS, $F }
    }

#
#  Create the static library
#
system($AR, @ARFLAGS, $ARCFILE, @OBJECTS) == 0
   or croak "Error while executing $AR @ARFLAGS $ARCFILE @OBJECTS\n".
   "message: $!\n";

#
#  Link the dynamic library
#

if ( -f "$WRK/$VMAKE_VERSION/obj/$DLLBASE.rbj" ) {
   push @OBJECTS, "$WRK/$VMAKE_VERSION/obj/$DLLBASE.rbj";
}

if ( $NODLL eq "" ) {
	$LIBPATH = "-L$TOOL/lib";

	# shared library <libname>.o requires list of extern procs
	# to be exported and list(s) of all still unresolved symbols
	($BASE) = $DLL =~ /(.*)\./;
	system("nm -ehC @OBJECTS | grep ' T' | cut -f1 -d'|' | cut -c2- | sort -u > $BASE.exp");
        @LDCMD=("ld");
        push @LDCMD, "-o", $DLL, $LIBPATH, @LDFLAGS, @OBJECTS;
        push @LDCMD, "-bE:$BASE.exp", "-bM:SRE", @IMPLIST, @LIBMATH, "-lc";
        system(@LDCMD);
#	system("ld -o $DLL $LIBPATH @LDFLAGS @OBJECTS -bE:$BASE.exp -bM:SRE @IMPLIST @LIBMATH -lc ");
	unlink "../obj/$BASE.exp";
	rename("$BASE.exp", "../obj/$BASE.exp");
}
else {
   # don't create shared library
   # vmake needs a dummy
	if ( -f $DLL ) { my($now)=time; utime($now, $now, $DLL)}
	else {
		open(FILE_OUT, ">>$DLL") or croak "Can't open $DLL (touch): $!\n";
		close FILE_OUT;
	}
}


if ( @KEEPFLG == 0 ) {

   unlink "$DLLBASE.res";
   unlink "$DLLBASE.rbj";
   # unlink "$DEF";
   if ( $NODLL eq "" && -f $DLL && -f "$ARCBASE.map" ) {

      unlink "$ARCBASE.tmp", "$ARCBASE.exp";
      if ( ! -d "$WRK/$VMAKE_VERSION/map" ) {
		mkdir("$WRK/$VMAKE_VERSION/map", 0775)
	  }
	  unlink "$WRK/$VMAKE_VERSION/map/$ARCBASE.map";
	  rename "$ARCBASE.map", "$WRK/$VMAKE_VERSION/map/$ARCBASE.map";
   }
   else {
	unlink "$ARCBASE.tmp", "$ARCBASE.exp", "$ARCBASE.map";
   }

}

if ( $DLLFILE ne $DLL && -f $DLL ) { unlink $DLLFILE; rename $DLL, $DLLFILE }


__END__


Hier knnen lange Kommentare stehen
