#!/devtool/local/bin/perl
# linklnk       *** internal script (called by vmake !)
#
# @(#)linklnk		1997-11-18
#
# link pascal object modules to create executable image
#
# TOOL          directory for tools
# LDFLAGS       optional loader flags
# KEEPFLG       optional keep intermediate files flag
#
# 1996-10-16 G. Gromann: -lib=ptocnt[s|r] in Descriptions setzt @LIBPC explizit neu
# 			  mit $TOOL/lib/ptocnt[s|r].lib
#
# 1997-02-04 GG: Map-Files werden nach $SYS/map/$VMAKE_VERSION verschoben
package linklnk;
use Env;
use File::Copy;

# Get LDFLAGS, LD, LIB*
do "$TOOL/bin/toolvars$TOOLEXT";
if ( $@ ) { print "$@"; exit }
ToolTrace("linklnk called with @ARGV\n");

$USAGE = "usage: linklnk [-p] [ld-flags] objects\n";

$DEBUG  = "";
$PROF   = "";
$SCRIPT = "";
$RCFILE = "";

push @LDFLAGS, @LDEXEFLAGS;
$OUTFILE = "a.out";
$PROG = $OUTFILE;   # some systems forbid some extensions for executables

while ($_ = $ARGV[0], /^-/) {
    shift;
    last if /^--$/;


    if (/^-x=(.*)/) { $SCRIPT = $1; next }

    if (/^-rc=(.*)/) { $RCFILE = $1; next }

    if(/^-ico=.*|^-dlg=.*|^-rcinc=.*|^-inc=.*/) { push @RCINCL, $_; next }

    if (/^-noscrlib$/) { @LIBSCR = (); next}


    if (/^-o$/) {
        $OUTFILE = $ARGV[0];
        $OUTFILE =~ /(.*)\.[fqs]/, $PROG = $1 ne "" ? $1 : $OUTFILE ;
        shift;  # do an extra shift for program name
	    next;
    }

    if (/^-g$/) { $DEBUG = "y"; next }

    if (/^-p$/) {
        push @LDFLAGS, "-p";
		next;
	}

    if (/^-k$/) { @KEEPFLG = "-k"; next }

    if (/^-.*/) { push @LDFLAGS, $_; next }

 } #while

if ( @ARGV < 1 ) { print $USAGE;  exit 1; }


	@OBJECTS = @ARGV;

CreateLinkNrModule() if (! -f "$BuildModule.o");
push @OBJECTS, "$BuildModule.o";
push @CMD, $LD, @LDFLAGS;
push @CMD, ( "-o", "$PROG" );
push @CMD, ( "-L$TOOL/lib" );
push @CMD, @OBJECTS;
push @CMD, @LIBPC;
push @CMD, @LIBSCR;
push @CMD, @LIBMATH;
push @CMD, @LIBNET;
push @CMD, @LIBMPROC;
push @CMD, @LIBAIO;
ToolTrace("linklnk called:\n@CMD");
system(@CMD) == 0
	 or die "Error while executing $LD @LDFLAGS ...\n".
	 "message: $!\n";


if ( @KEEPFLG == 0 ) {
   unlink "$BuildModule.c";
   if ( -f $PROG && -f "$BASE.map" ) {
      if ( ! -d "$WRK/$CURR_VERSION/map" ) {
		mkdir("$WRK/$CURR_VERSION/map", 0775);
	  }
	  unlink "$WRK/$CURR_VERSION/map/$BASE.map";
      rename "$BASE.map", "$WRK/$CURR_VERSION/map/$BASE.map";
   }
}

if ( $OUTFILE ne $PROG ) { unlink $OUTFILE; rename($PROG, $OUTFILE) }


###############################################################

sub CreateLinkNrModule {
$ENV{LINKNUMBER} = 4711 if ! $ENV{LINKNUMBER};
#print ("\n CreateLinkNrModule: BuildModule -> $BuildModule.c\n");
 $BuildModule="Huild";
    open(FILE_OUT1, ">$BuildModule.c") || die "Can't open $BuildModule.c (output) :$!\n";
    #open(FILE_OUT1, ">/is8800_d4/V62T/sys/wrk/slow/tmp/Build.c") || die "Can't open $BuildModule.c (output) :$!\n";

print FILE_OUT1 "$MF_ID \"@(#)Build: $ENV{LINKNUMBER}\" $ID_END\n";
print FILE_OUT1 "int s98linknumber(){int linknr=$ENV{LINKNUMBER}; return linknr;}";
    
    #print FILE_OUT <<End_of_File;
#$MF_ID "@(#)Build: $ENV{LINKNUMBER}" $ID_END
#int s98linknumber(){int linknr=$ENV{LINKNUMBER}; return linknr;}
#End_of_File
    close FILE_OUT1;
#die ("ENDE");
    {
        local @ARGV = ( @KEEPFLG, "$BuildModule.c");
print ("\n CreateLinkNrModule1: BuildModule -> $BuildModule.c\n");
        do "$TOOL/bin/compc$TOOLEXT";
        if ( $@ ) { print "$@"; exit }
   }
}
