#	for F in `cat $LIST`
#		do
#			iview -e0 $F
#		done
#
#	rem -us cp $GRP/sys/man/kernel.xref $TMP
#fi

use Env;
use Getopt::Std;
use ICopy;

if (!getopts ('lh') || $opt_h) {
  print <DATA>;
  exit;
}

$LIST="$TMP/sourcelist";

print "collecting files ...\n";

open(SAVESTDOUT, ">&STDOUT"); close(STDOUT);
open(STDOUT, ">$LIST.tmp");

foreach $File ( "diagnose", "audit", "prtprot" ) {
@ARGV = ("-m", "$File");
$Returncode = do "$TOOL/bin/imf$TOOLEXT";
if ( $@ ) { die "Error while executing imf$TOOLEXT: $@" }
}

foreach $File ( "slowci", "slowknl" ) {
@ARGV = ("-m", "$File");
$Returncode = do "$TOOL/bin/ims$TOOLEXT";
if ( $@ ) { die "Error while executing imf$TOOLEXT: $@" }
}

close(STDOUT);
open(STDOUT, ">&SAVESTDOUT"); close(SAVESTDOUT);

system("$TOOL/Posix/sort -o $LIST.tmp -u $LIST.tmp");

open(INFILE, "<$LIST.tmp");
open(OUTFILE, ">$LIST");

print "getting files ... \n"  unless ($opt_l);

while ( <INFILE> ) {

    if ( m !/[a-z][a-z]/(.*)!) {
       ($MOD) = $_ =~ /([a-z]{3,}\d{2,}$)/i;
       print OUTFILE $_;
       ICopy::iview([$MOD], 0, 0, 0, 1) unless ($opt_l);
   }

}

close (INFILE); unlink ("$LIST.tmp");

foreach $File  ("ven101", "ven102", "ven103", "vgg10") {
    print OUTFILE "$_\n";
    ICopy::iview([$MOD], 0, 0, 0, 1) unless ($opt_l);
    }


close (OUTFILE);

__DATA__

 USAGE: getsource [-h] [-l]

           Creates a list of all modules used in
           slowknl, slowci, diagnose, audit and prtprot
           and copied them to $TMP

 OPTIONS:    -h    prints this help
             -l    only creates a list
