#!/devtool/local/bin/perl
# @(#) knl-tcc	1995-08-01  Torsten Strahl
#
# Type-Check fuer alle Module, die von der Kerngruppe gepflegt
# werden.

use Env;
use Getopt::Std;


if (!getopts('lhp') || $opt_h) {

    print <DATA>;
    exit 1;
}

$Local    = "";
$Local    = "-l" if ( $opt_l );
$MakeProt = $opt_p;



chdir("$WRK/fast/prot") || die "Can't change to directory $WRK/fast/prot: $!";

unlink("$TMP/all", "$TMP/all1");

if ( $MakeProt ) {
  open(SAVESTDOUT, ">&STDOUT"); close(STDOUT);
  open(STDOUT, ">knl-tcc.prt");
}

print "\n+++++ T C C +++++\n";
print "prepare list of files .";

open(SAVEOUT, ">&STDOUT");
open(STDOUT, ">$TMP/all");

if (@ARGV != 0) {
    @desc = @ARGV;
    foreach $desc (@desc) {
	@ARGV = ("-m", $desc);
	do "$TOOL/bin/imf$TOOLEXT";
	if ( $@ ) { die "Error while executing ims$TOOLEXT: $@" }
    }
}
else {
    @ARGV = ("-m", "all");
    do "$TOOL/bin/imf$TOOLEXT";
    if ( $@ ) { die "Error while executing ims$TOOLEXT: $@" }

    @ARGV = ("-m", "allknl");
    do "$TOOL/bin/ims$TOOLEXT";
    if ( $@ ) { die "Error while executing ims$TOOLEXT: $@" }
}


close(STDOUT);
open(STDOUT, ">&SAVEOUT");

# Die Sourcen, die von uns verwendet, aber nicht gepflegt werden,
# kommen nicht in die Liste. Zusaetzlich wird von allen Modulen
# die Variantenkennung abgeschnitten.

open(FILE_IN, "<$TMP/all");
LINE:
while(<FILE_IN>) {
    chop;
    if (/00/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/^.*\.bpl$/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/^.*\.cpp$/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/^.*\.dll$/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/^.*c$/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/^.*\.h$/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/wd/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/px/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/dx/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/ox/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/zz/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/r3/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/ven/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/Resource/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/vos/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/veo/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/vmt/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/jk/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/xx/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/rx/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/kx/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/desc\/slow/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/desc\/quick/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/desc\/fast/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/VMAKE_PATH/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
    if (/WARNING/) {
        s/^.*\n?//;
        redo LINE if $_;
        next LINE;
    }
	push @FILE_OUT, $_."\n";
}
close(FILE_IN);
@FILE_OUT = sort @FILE_OUT;
open(FILE_OUT, ">$TMP/all1");
undef($prevline);
foreach $out (@FILE_OUT) {
	next if $prevline eq $out;
	$prevline = $out;
	print FILE_OUT $out;
}
close(FILE_OUT);

print "... ";
open(FILE_IN, "<$TMP/all1"); local @count = <FILE_IN>;
print "check ", scalar(@count),  " files ...\n";
seek FILE_IN, 0, 0;
while(<FILE_IN>) {
    chomp;
    if ( m!^src/ak/vak260!i or m!^src/ak/vak36!i or m!^dg.*!i ) {
       if ( $Local eq "" )
	   {
   		   @ARGV = ( "-D", "INLINK", $_);
	   }
	   else
	   {
   		   @ARGV = ($Local, "-D", "INLINK", $_);
	   }
		do "$TOOL/bin/itcc$TOOLEXT";
		if ( $@ ) { die "Error while executing itcc$TOOLEXT: $@" }
    }
	else {
       if ( $Local eq "" )
	   {
          @ARGV = ( $_);
	   }
	   else
	   {
          @ARGV = ($Local, $_);
	   }
		do "$TOOL/bin/itcc$TOOLEXT";
		if ( $@ ) { die "Error while executing itcc$TOOLEXT: $@" }
    }
}
close(FILE_IN);
unlink("$TMP/all", "$TMP/all1");


if ( $MakeProt ) {
close(STDOUT);
open(STDOUT, ">&SAVESTDOUT"); close(SAVESTDOUT);
}




__DATA__


  USAGE:  knl-tcc [-pl] [component]

          calls itcc for every modul used by the kernel or by
          the component argument.

  OPTIONS:

          -h  : prints this help screen
          -l  : open source in $TMP
          -p  : creates a summary in $WRK/fast/prot/knl-tcc.prt

