#!/devtool/local/bin/perl
# @(#) sutsingle   6.1.1   1994-10-27   kern   admin
#
# Eine Liste von Teststromnamen wird vom Standard-Input
# eingelesen und fuer jedes Element das gewuenschte Programm
# aufgerufen. Das entstehende Protokoll mit einem als korrekt
# festgeschriebenen Protokoll verglichen.
#
# Aenderungen:
#
use Env;
use File::Basename;
use File::Copy;
use Carp;
use Cwd;
use ToolLib;
require "hostname.pl";
do "$TOOL/bin/sutvars$TOOLEXT";
warn "sutstack obsolete - use sutsingle with option '-stack'";

if ($RELVER eq "R61"){
	$X_PROG = $X_UTIL;
}
else{
	$X_PROG = $X_DIAGNOSE;
}

$USAGE = "usage: sutsingle version program [dbname [dbremote]]  teststream.vdnts, ... \n";

if ( $ARGV[$#ARGV] !~ /.+\.vdnts/ ) { die "teststreams have to named with the extension '.vdnts'" }

if  ( $SUT ne "" ) {
	local $cwd = cwd(); $cwd =~ tr[\\][/];
	$SUT =~ tr[\\][/];
	if  ( $cwd !~ /$SUT/i ) {
		print "cd $SUT";
		chdir($SUT) || die "Can't change to directrory $SUT: $!";
	}
}

if ( $^O =~ /mswin32/i )  {
	$DrWtsnFile = "$WINDIR/drwtsn32.log";
	unlink "$WINDIR/drwtsn32.bak"; rename("$WINDIR/drwtsn32.log", "$WINDIR/drwtsn32.bak");
}

open(FILE_OUT, ">debuginput");
$DEBUG = "adb";
print FILE_OUT "\$c\n\$r\n\$q\n";
close(FILE_OUT);

if  ( @ARGV < 2 ) { print "$USAGE"; exit 1 }

my $VERSION = shift;
my $PROGRAM = shift;

if ( $ARGV[0] !~ /.+\.vdnts/i ) { $DBNAME = shift }
if ( $ARGV[0] !~ /.+\.vdnts/i ) { $DBREMOTE = shift }

if ( ! $DBNAME ) {
    croak "ERROR: name of the database is not defined!\n";
}

$_ = $VERSION;
CASE: {
	if (/^fast$/i) {
		$DBPROG = "$DBROOT/pgm/kernel$PROG_EXT";
		$SUTOPTION = "-fast";
		last CASE
	}

	if (/^slow$/i) {
		$DBPROG = "$DBROOT/pgm/slowknl$PROG_EXT";
		$SUTOPTION = "-slow";
		last CASE
	}

	if (/^quick$/i) {
		$DBPROG = "$DBROOT/pgm/quickknl$PROG_EXT";
		$SUTOPTION = "-quick";
		last CASE
	}

	print "$USAGE";
	print "version: fast|quick|slow\n";
	exit 1;
} # CASE

$ENV{SUTOPTION} = $SUTOPTION;
my $PVERS = substr($VERSION, 0, 1);
my $PROG = "$DBROOT/pgm/$PROGRAM";

if ( $PROGRAM =~ /^sqlterm/i ) { $Sqlterm  = 1;  } else { $Sqlterm  = 0; }
if ( $DBBIGCMD )       { $Dbbigcmd = 1;  } else { $Dbbigcmd = 0; }

if  ( ! -x $PROG ) { print "$USAGE"; die "program $PROG not executable\n" }
if  ( ! -f $DBPROG ) { die "can't find $DBPROG\n" }

$ENV{SERVERDB} = $DBNAME;
if  ( ! -r "$PARAMDIR/$DBNAME" ) {
    print "$USAGE";
    croak "param file $PARAMDIR/$DBNAME not readable\n";
}
system("x_stop $DBNAME >$NULL 2>&1");

if ( $DBREMOTE ) {

    $ENV{DBREMOTE} = $DBREMOTE;
    if ( $DBREMOTE ne "" ) {
		do "$TOOL/bin/xinitdst$TOOLEXT";
		if ( $@ ) { die "Error while executing xinitdst:\n", "$@"; exit }
		$HASCORE = "init";
	}
    if ( ! -r "$PARAMDIR/$DBREMOTE" ) {
        print "$USAGE";
        croak "param file $PARAMDIR/$DBREMOTE not readable\n";
	}
    system("x_stop $DBREMOTE >$NULL 2>&1");

}
#	Ermittle ob die Variable DBUNICODE gesetzt ist
#	und setze danach den XPARAM Parameter.

$DEF_CODE = "ASCII";

if ($RELVER ne "R61"){
	if ( ! $DBUNICODE ) {
		system("$DBROOT/pgm/putparam $DBNAME _UNICODE NO") == 0
			or croak "Error while executing \"$DBROOT/pgm/putparam $DBNAME _UNICODE NO\"\n".
			"message: $!\n";
	}
	else {
	    	system("$DBROOT/pgm/putparam $DBNAME _UNICODE YES") == 0
		    	or croak "Error while executing \"$DBROOT/pgm/putparam $DBNAME _UNICODE YES\"\n".
			    "message: $!\n";
		if ( $DEFCODE eq "" ) { $DEF_CODE = "ASCII" } else { $DEF_CODE = $DEFCODE }
	}
}

#	Ermittle den Namen des Protokolls durch Aufruf des Programmes
#	und auflisten der dadurch erzeugten Datei.

$CI_PROT = ToolLib::ProtokollName($PROG);

if ( $TMP eq "" ) { $TMPDIR = "/tmp" } else { $TMPDIR = $TMP }

# Variablen fuer DBNAME
$DBPARAM = "$DBROOT/pgm/getparam $DBNAME";
$DBPARAM = "$DBROOT/pgm/getparam $DBNAME";

if ($RELVER eq "R61"){
	$RUNDIR  = `$DBPARAM RUNDIRECTORY`;		chomp $RUNDIR;
	$OPMSG3  = `$DBPARAM DIAGFILE`;			chomp $OPMSG3;
	$KDUMP   = `$DBPARAM KERNELDUMPFILE`;	chomp $KDUMP;
	$KNLDIAG = `$DBPARAM DIAGFILE`;			chomp $KNLDIAG;
}
else{
	$RUNDIR  = `$DBPARAM RUNDIRECTORY`;		chomp $RUNDIR;
	$OPMSG3  = `$DBPARAM _KERNELDIAGFILE`;	chomp $OPMSG3;
	$KDUMP   = `$DBPARAM  _KERNELDUMPFILE`; chomp $KDUMP;
	$KNLDIAG = `$DBPARAM _KERNELDIAGFILE`;	chomp $KNLDIAG;
	$RDUMP   = `$DBPARAM  _RTEDUMPFILE`;	chomp $RDUMP;
}

if ( $DBREMOTE ) {
    # Variablen fuer DBREMOTE
    $RMDBPARAM= "$DBROOT/pgm/getparam $DBREMOTE";
    $RMRUNDIR = `$RMDBPARAM RUNDIRECTORY`;			chomp $RMRUNDIR;
    $RMOPMSG3 = `$RMDBPARAM _KERNELDIAGFILE`;		chomp $RMOPMSG3;
    $RMKDUMP  = `$RMDBPARAM  _KERNELDUMPFILE`;		chomp $RMKDUMP;
    $RMRDUMP  = `$RMDBPARAM  _RTEDUMPFILE`;			chomp $RMRDUMP;
}

$dir = dirname($KNLDIAG);
if ( $dir eq "." or $dir eq ".." ) { $DIAG = "$RUNDIR/$KNLDIAG" } else { $DIAG = $KNLDIAG }
$dir = dirname($KDUMP);
if ( $dir eq "." or $dir eq ".." ) { $DUMP = "$RUNDIR/$KDUMP" } else { $DUMP = $KDUMP }
$dir = dirname($RDUMP);
if ( $dir eq "." or $dir eq ".." ) { $RDMP = "$RUNDIR/$RDUMP" } else { $RDMP = $RDUMP }

if ( $DBREMOTE )  {
	$dir = dirname($RMOPMSG3);
	if ( $dir eq "." or $dir eq ".." ) { $RMDIAG = "$RMRUNDIR/$RMOPMSG3" } else { $RMDIAG = $RMOPMSG3 }
	$dir = dirname($RMKDUMP);
	if ( $dir eq "." or $dir eq ".." ) { $RMDUMP = "$RMRUNDIR/$RMKDUMP" } else { $RMDUMP = $RMKDUMP }
	$dir = dirname($RMDUMP);
	if ( $dir eq "." or $dir eq ".." ) { $RMRDMP = "$RMRUNDIR/$RMRDUMP" } else { $RDMP = $RDUMP }
}

# Aktualisierung des Paramfiles! Durch den Vergleich der Kernel-
# version des Paramfiles und des Kerns beim Hochfahren musste
# vor Beginn der Testlaeufe immer das Paramfile von Hand erzeugt
# werden, wenn der Kern gestempelt wurde. Dies entfaellt jetzt.

system("x_param -u superdba,colduser -d $DBNAME -v BCHECK") == 0
	or croak "Error while executing \"x_param -u superdba,colduser -d $DBNAME -v BCHECK\"\n".
	"message: $!\n";
$Returncode = $?;
if ( $Returncode != 0 ) {
   print "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n\n";
   print "ERROR BY EXECUTING XPARAM FOR $DBNAME !\n";
   print "Returncode is $Returncode\n";
   print "For further informations see xparam.prot and xpcheck.prot!\n\n";
   print "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n";

   print "One more try! x_param BCHECK ...\n";
   system("x_param -u superdba,colduser -d $DBNAME -v BCHECK") == 0
		or croak "Error while executing \"x_param -u superdba,colduser -d $DBNAME -v BCHECK\"\n".
		"message: $!\n";
}

$Returncode = $?;
if ( $Returncode != 0 ) { print "Error by executing xparam!\n"; exit 1 }

# Note, that it is important to rename old style xuser files, too...
if ( -f "$HOME\\.XUSER"    ) { unlink "$HOME/.XUSER.sav"; rename("$HOME/.XUSER",    "$HOME/.XUSER.sav") }
if ( -f "$HOME\\.XUSER.62" ) { unlink "$HOME/.XUS62.sav"; rename("$HOME/.XUSER.62", "$HOME/.XUS62.sav") }

unlink "lock";
$DBHIF = $TERM;

print scalar localtime, "\n";
if ( $DBREMOTE ) { print " DBNAME = $DBNAME DBREMOTE = $DBREMOTE\n" } else { print " DBNAME = $DBNAME\n" }

if ( ! $REKURS ) {
	open(FILE_OUT, ">$AllProt"); print FILE_OUT scalar localtime, "\n"; close(FILE_OUT);
	open(FILE_OUT, ">$AllCore"); close(FILE_OUT);
	open(FILE_OUT, ">$AllDiff"); close(FILE_OUT);
	open(FILE_OUT, ">$AllOk");   close(FILE_OUT);
}

#===================================================================
# Abarbeiten der Teststroeme
#===================================================================
# Die SUTs laufen mit einem vorgefertigten Paramfile

# transsize: 100 datasize: 400 code: ASCII archivesize: 200
install_paramfile( $DEF_CODE );
@TFNS = @ARGV;
foreach $TFN ( @TFNS ) {

	$TFN =~ s/\.vdnts//i;
    while ( -f "lock" ) { sleep 10 }

    # fuer eine gleichmaessige Ausgabe in 'allsut'
	my $PTEST = $TFN." "x(8-length($TFN));
	open(FILE_IN, "<CONNECT.cmd");
	while(<FILE_IN>) {
		if ( /^CONNECT &1 IDENTIFIED BY &2 &3 &4 ISOLATION LEVEL (\d+).*/i ) {
			$LEVEL = $1; last;
		}
	}
	close(FILE_IN);
	open(FILE_OUT, ">>$AllProt");
    print FILE_OUT ToolLib::Timestamp(1), "\t$PVERS $LEVEL $PTEST\n"; close(FILE_OUT);

    if ( ! -f "$TFN.vdnts" ) {
		open(FILE_OUT, ">>$AllProt");
        print FILE_OUT "NOT FOUND: $TFN.vdnts\n"; close(FILE_OUT);
        print "NOT FOUND: $TFN.vdnts\n";
        next;
	}

    $ProtDir = "$SUT/stack";
    # Ueberbleibsel des alten Testlaufs entfernen
	unlink <$RUNDIR/core*>, <*host*>, "shmcore", <*.HOST*>, $CI_PROT;
    unlink "$ProtDir/$TFN.core", "$ProtDir/$TFN.dump", "$ProtDir/$TFN.rtedump", "$ProtDir/$TFN.prot", "$ProtDir/$TFN.pdiff";
	unlink <$RMRUNDIR/core*>;

    # Da einige Teststroeme ein spezielles Paramfile benoetigen
    # wird vor dem eigentlichen Lauf das entsprechende Paramfile
    # kopiert.

	CASE: {
	if ( $TFN =~ /JOIN2TAB|LINKDDL|NIST3|USERTEST/i) {
           install_paramfile( EBCDIC );
		   last CASE; }
	if ( $TFN =~ /STAV|STAU|UPDSTAT/i) {
           install_paramfile( ASCII );
		   last CASE; }
	if ( $TFN =~ /SELFET1|SELFET2/i) {
           copy("$RUNDIR/xinitdb.sav", "$RUNDIR/xinitdb.sav2");
           system("$DBROOT/pgm/putparam $DBNAME _MAXSERVERDB 1") == 0
				or croak "Error while executing \"$DBROOT/pgm/putparam $DBNAME _MAXSERVERDB 1\"\n".
				"message: $!\n";
		   $REKURS = "X"; $ENV{'REKURS'} = $REKURS;
		   local @ARGV = ($VERSION, "slowci$PROG_EXT", $DBNAME, "XINITDB.vdnts");
			do "$TOOL/bin/sutsingle$TOOLEXT";
			if ( $@ ) { die "Error while executing sutsingle:\n", "$@"; exit }
		   undef($REKURS);
		   last CASE; }
	} #CASE


	CASE: {
		if ( $TFN =~ /^Y.*/ ) { $RESTORE = "YRESTORE"; last CASE; }
		if ( $TFN =~ /^W.*/ ) { $RESTORE = "WRESTORE"; last CASE; }
		$RESTORE = "XRESTORE";
	}

    if ( $DBREMOTE ) {
		copy("$RESTORE.cmd", "$RESTORE.sav");
		copy("XRESTDST.cmd", "$RESTORE.cmd");
    }

    if ( $Dbbigcmd != 0 ) {
        # Um groessere SQL Kommandos zu erhalten werden durch
        # das XCI Kommando "BIGCMD <offset>" Blanks vor jedes
        # SQL  Kommando geschrieben.
		open(FILE_OUT, ">>$RESTORE.cmd");
        print FILE_OUT "BIGCMD $DBBIGCMD !\n"; close(FILE_OUT);
    }

    if ( $DBUNICODE =~ /^xci/i ) {
		if ( $DBLANG ne "" ) {
			# Da der XCI hier garantiert nur Zeichen aus dem ASCII-Subset der
			# entsprechenden Kodierung schickt, wird ihm mit TERMINAL ASCII
			# mitgeteilt, dass er bei der Ausgabe von UNICODE-Spalten nur
			# halb soviel Platz benoetigt, wie der Kern ihm mitteilt.
			open(FILE_OUT, ">>$RESTORE.cmd");
			print FILE_OUT "TERMINAL ASCII!\n"; close(FILE_OUT);
		}
		else {
			# Diese Kombination der Umgebungsvariablen sagt aus, dass
			# der XCI die Auftragsschnittstelle als Unicode-Client
			# bedienen soll. Das wird ihm durch Aufruf des Kommandos
			# TERMINAL UNICODE am Anfang eines Testlaufs mitgeteilt.
			open(FILE_OUT, ">>$RESTORE.cmd");
			print FILE_OUT "TERMINAL UNICODE!\n"; close(FILE_OUT);
		}
    }
    if ( $DBUPDSTAT ) {
		# Hier wird jetzt das Diagnose-Kommando abgesetzt, das den Kern
		# dazu bringt, beim UPDATE STATISTICS immer eine grosse Zahl als
		# Page-Anzahl einzutragen. Dadurch werden dann in der Strategie-
		# suche auch mal einige Indizes genommen statt immer nur Table Scan...
		local $TMP = "$::TMP/REST$$";
		copy("$RESTORE.cmd", $TMP);
		open(FILE_OUT, ">$RESTORE.cmd"); open(FILE_IN, "<$TMP");
		while(<FILE_IN>) {
			print FILE_OUT $_;
			print FILE_OUT "DIAGNOSE OPTIMIZE UPDSTAT ON\n" if /autosave on/;
		}
		close(FILE_IN); close(FILE_OUT);
		unlink($TMP);
    }

    if ( $TFN =~ /^ENTRY/i ) {
	    unlink "$TFN.ori"; rename("$TFN.vdnts", "$TFN.ori") || warn "Can't rename $TFN.vdnts to $TFN.ori: $!";
	    #system("$TOOL/Posix/sed -e \"s/<serverdb>/$DBNAME/g\" < $TFN.ori > $TFN.vdnts");
		open(FILE_IN, "<$TFN.ori" ); open(FILE_OUT, ">$TFN.vdnts" );
		while(<FILE_IN>) {
			s/<serverdb>/$DBNAME/g;
			print FILE_OUT $_;
		}
		close(FILE_IN); close(FILE_OUT);
    }

    if ($RELVER eq "R61"){
		# Specify the kernel version in the registry
		$main::HKEY_LOCAL_MACHINE->Open("SYSTEM\\CurrentControlSet\\Services\\ADABAS-$DBNAME", $RegADA)
			|| die "Cannot open registry key!\n";

		$RegADA->SetValueEx('ImagePath', 0, REG_EXPAND_SZ, "$DBPROG")
			|| die "Cannot register kernel version $VERSION in the registry!\n";
	}

    if ( $DBREMOTE ) {
	# - Weil die verteilten Tests nicht jedesmal ein neues INIT CONFIG
	#   machen, laufen Dinge wie Stamps, Session, etc. auseinander.
	#   Es gibt Testlaeufe, wo solche Dinge explizi